---
title: 'SVGGraphicsElement: copy event'
slug: Web/API/SVGGraphicsElement/copy_event
tags:
  - API
  - Event
  - Reference
  - SVG
  - SVG OM
---
<p>{{APIRef}}</p>

<p><span class="seoSummary">The <strong><code>copy</code></strong> event fires on {{domxref("SVGGraphicsElement", "SVGGraphicsElements")}} when the user initiates a copy action through the browser's user interface.</span></p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("ClipboardEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("SVGGraphicsElement/oncopy", "oncopy")}}</td>
  </tr>
 </tbody>
</table>

<p>The event's default action is to copy the selection (if any) to the clipboard.</p>

<p>A handler for this event can <em>modify</em> the clipboard contents by calling {{domxref("DataTransfer.setData", "setData(format, data)")}} on the event's  {{domxref("ClipboardEvent.clipboardData")}} property, and cancelling the event's default action using <code><a href="/en-US/docs/Web/API/Event/preventDefault">event.preventDefault()</a></code>.</p>

<p>However, the handler cannot <em>read</em> the clipboard data.</p>

<p>It's possible to construct and dispatch a <a href="/en-US/docs/Web/Guide/Events/Creating_and_triggering_events">synthetic</a> <code>copy</code> event, but this will not affect the system clipboard.</p>

<h2 id="Example">Example</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;svg viewBox="0 0 100 30" width="600" height="320" xmlns="http://www.w3.org/2000/svg"&gt;
    &lt;text x="5" y="10" id="text-to-copy"&gt;Copy this text&lt;/text&gt;
    &lt;foreignObject x="5" y="20" width="90" height="20"&gt;
        &lt;input xmlns="http://www.w3.org/1999/xhtml" placeholder="Paste it here"/&gt;
    &lt;/foreignObject&gt;
&lt;/svg&gt;</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css">input {
  font-size: 10px;
  width: 100%;
  height: 90%;
  box-sizing: border-box;
  border: 1px solid black;
}
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js; highlight[1]">document.getElementsByTagName("text")[0].addEventListener("copy", evt =&gt; {
  evt.clipboardData.setData('text/plain', document.getSelection().toString().toUpperCase());
  evt.preventDefault();
});</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example", "620", "340")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("SVG2", "types.html#SVGDOMDependencies")}}</td>
   <td>{{Spec2("SVG2")}}</td>
   <td>Definition that the clipboard events apply to SVG elements.</td>
  </tr>
  <tr>
   <td>{{SpecName('Clipboard API', '#clipboard-event-copy')}}</td>
   <td>{{Spec2('Clipboard API')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.SVGGraphicsElement.copy_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Related events: <code><a href="/en-US/docs/Web/API/SVGGraphicsElement/cut_event">cut</a></code>, <code><a href="/en-US/docs/Web/API/SVGGraphicsElement/paste_event">paste</a></code></li>
 <li>This event on HTML {{domxref("Element")}} targets: <code><a href="/en-US/docs/Web/API/Element/copy_event">copy</a></code></li>
 <li>This event on {{domxref("Document")}} targets: <code><a href="Web/API/Document/v_event">copy</a></code></li>
 <li>This event on {{domxref("Window")}} targets: <code><a href="Web/API/Window/copy_event">copy</a></code></li>
</ul>
